
#ifndef    __CONFIG_H
#define    __CONFIG_H
#include "stc15f2k61s2.h"
#include "string.h"
#include "stdio.h"
#include "math.h"
#include "intrins.h"
//=========INT0======================
 
extern void int0_init(void);
//==BEEP=======================================
sbit    BEEP=P0^5;

extern void  alarm(void);
extern void  qidong(void);
//===========================================
sbit     DQ=P0^4;//ʪȴ

extern unsigned char COM(void);
extern void RH();
extern void get_wendu();
extern void show_wendu();
//LCD12864=====================================================================================
 /*
      8λλP2
      1(GND)====GND
			2(VCC)====5V
			3(VO) ====NC
			4(RS)=====P41
			5(R/W)====P42
			6((E)=====P44
			7-14======P00-p07
			15(PSB)===1
			16(NC)====NC
			17(RST)===NC
			18(VOUT)==NC
			19(BLA)===5V
			20(BLK)===GND
*/
sbit    lcdrs=P4^1;
sbit    lcdrw=P4^2;
sbit    lcden=P4^4;
#define DATA  P2 
extern void LCD12864_init();
extern void write_data(unsigned char dat);
extern void write_com(unsigned char  com);
extern void disp_line(unsigned char x,unsigned char dat[16]);  //ʾ	ʾҺһ
extern void disp_string(unsigned char x,unsigned char y,unsigned char *s);	  //ʾ	ʾһַsҺ   xxУyyУӵXеYпʼд
extern void disp_num(unsigned char x,unsigned char y,unsigned char dat); 
extern void lcd12864_ShowNum(unsigned char x,unsigned char y,unsigned char num );
extern void Seperate(float Array,unsigned char z);
extern void Step_Seperate(int Array,unsigned char z);
//delay===================================================================================
extern void Delay10us();
extern void Delay1ms();
extern void Delay10ms();
extern void Delay100ms();
extern void Delay200ms();
extern void Delay1000ms();
extern void Delay2000ms();
//ڳʼ===============================================================================
 extern void Uart1Init(void);
 extern void Uart2Init(void);
//GPS======================================================================================
 extern void  show_position(void);
//==NRF24L01===============================================================================
/*-----------------------------SPIؼĴ----------------------------------------------*/
// SPCTL ƼĴ   BIT7   BIT6  BIT5   BIT4   BIT3  BIT2 BIT1 BIT0
//                   SSIG   SPEN  DORD   MSTR   CPOL  CPHA SPR1  SPR0
#define SPI_STAT      0X40   //ʹSPI
#define SPI_FLASH     0x9C   //ʱӸߵƽ  ڶز  һλΪλ     CPU_CLK/4   δSPI

#define SPI_NRF24L01  0x90   //ʱӵ͵ƽ  һز  һλΪλ     CPU_CLK/4   δSPI

//SPSTAT  ״̬Ĵ    BIT7  SPIF   ɱ־    BIT6  дͻ־    Ӧλд1

// SPDAT  ݼĴ
// IE      BIT7  EA       жϿ
// IE2    жĴ    BIT1  ESPI   SPIжλ
// IP2    жȼƼĴ  BIT1  PSPI    0ȼж     1ȼ
// P_SW1/AUXR1   лƼĴ1   BIT3 BIT2  SPI_S1 SPI_S0   
// 00  P12 P13 P14 P15   01 P24 P23 P22 P21    10 P54 P40 P41 P43   11Ч   ŷֱӦ  SS  MOSI  MISO   SCLK

extern void SPI_Init(void);  //ʱӸߵƽ  ڶز  һλΪλ     CPU_CLK/4  
extern void SPI_SWITCH(unsigned char num); //SPIл 0 P12 P13 P14 P15, 1 P24 P23 P22 P21, 2 P54 P40 P41 P43  Ч ŷֱӦ  SS MOSI MISO SCLK
extern void SPI_SPEED(unsigned char num);  //SPI ٶ  0~3  0Ϊٶ
extern unsigned char SPI_WRITE_READ(unsigned dat);  //SPI дֽ

//SPIӿ------------------  ʱΪ͵ƽ  һźŲɼ  ٶ10M-----------------------
/******************ӲSPI*************************************
#define MOSI    P13   
#define MISO    P14
#define SCLK    P15
*******************************************************************/

#define NRF24L01_IRQ     P55  // жź  ͵ƽΪжź
#define NRF24L01_CSN     P12  // SPI ʹź  Ƭѡź
#define NRF24L01_CE      P54  // ģʹź   ߵƽģʽ  ͵ģʽ  أ10us    ֻCEΪ͵ƽʱдĴ

//////////////////////////////////////////////////////////////////////////////////////////////////////////
//NRF24L01Ĵ
#define READ_REG_NRF    0x00  //üĴ,5λΪĴַ
#define WRITE_REG_NRF   0x20  //дüĴ,5λΪĴַ
#define RD_RX_PLOAD     0x61  //RXЧ,1~32ֽ
#define WR_TX_PLOAD     0xA0  //дTXЧ,1~32ֽ
#define FLUSH_TX        0xE1  //TX FIFOĴ.ģʽ
#define FLUSH_RX        0xE2  //RX FIFOĴ.ģʽ
#define REUSE_TX_PL     0xE3  //ʹһ,CEΪ,ݰϷ.
#define NOP             0xFF  //ղ,״̬Ĵ	 
//SPI(NRF24L01)Ĵַ
#define CONFIG          0x00  //üĴַ;bit0:1ģʽ,0ģʽ;bit1:ѡ;bit2:CRCģʽ;bit3:CRCʹ;
                              //bit4:жMAX_RT(ﵽطж)ʹ;bit5:жTX_DSʹ;bit6:жRX_DRʹ
#define EN_AA           0x01  //ʹԶӦ  bit0~5,Ӧͨ0~5
#define EN_RXADDR       0x02  //յַ,bit0~5,Ӧͨ0~5
#define SETUP_AW        0x03  //õַ(ͨ):bit1,0:00,3ֽ;01,4ֽ;02,5ֽ;
#define SETUP_RETR      0x04  //Զط;bit3:0,Զط;bit7:4,Զطʱ 250*x+86us
#define RF_CH           0x05  //RFͨ,bit6:0,ͨƵ;
#define RF_SETUP        0x06  //RFĴ;bit3:(0:1Mbps,1:2Mbps);bit2:1,书;bit0:Ŵ
#define STATUS          0x07  //״̬Ĵ;bit0:TX FIFO־;bit3:1,ͨ(:6);bit4,ﵽط
                              //bit5:ݷж;bit6:ж;
//״̬б-------------															
#define MAX_TX  		  0x10  //ﵽʹж
#define TX_OK   		  0x20  //TXж
#define RX_OK   		  0x40  //յж

#define OBSERVE_TX      0x08  //ͼĴ,bit7:4,ݰʧ;bit3:0,ط
#define CD              0x09  //زĴ,bit0,ز;
#define RX_ADDR_P0      0x0A  //ͨ0յַ,󳤶5ֽ,ֽǰ
#define RX_ADDR_P1      0x0B  //ͨ1յַ,󳤶5ֽ,ֽǰ
#define RX_ADDR_P2      0x0C  //ͨ2յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P3      0x0D  //ͨ3յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P4      0x0E  //ͨ4յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P5      0x0F  //ͨ5յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define TX_ADDR         0x10  //͵ַ(ֽǰ),ShockBurstTMģʽ,RX_ADDR_P0˵ַ
//ͨЧݿ----------------------------
#define RX_PW_P0        0x11  //ͨ0Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P1        0x12  //ͨ1Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P2        0x13  //ͨ2Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P3        0x14  //ͨ3Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P4        0x15  //ͨ4Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P5        0x16  //ͨ5Чݿ(1~32ֽ),Ϊ0Ƿ
#define NRF_FIFO_STATUS 0x17  //FIFO״̬Ĵ;bit0,RX FIFOĴձ־;bit1,RX FIFO־;bit2,3,
                              //bit4,TX FIFOձ־;bit5,TX FIFO־;bit6,1,ѭһݰ.0,ѭ;
//////////////////////////////////////////////////////////////////////////////////////////////////////////

//24L01ͽݿȶ
#define TX_ADR_WIDTH    5   	//5ֽڵĵַ
#define RX_ADR_WIDTH    5   	//5ֽڵĵַ
#define TX_PLOAD_WIDTH  32  	//32ֽڵûݿ
#define RX_PLOAD_WIDTH  32  	//32ֽڵûݿ

void  NRF24L01_Init(void);
unsigned char      NRF24L01_Write_Reg(unsigned char   reg,unsigned char   value);          //ָĴд
unsigned char      NRF24L01_Read_Reg(unsigned char   reg);                    //Ĵ
unsigned char      NRF24L01_Read_Buf(unsigned char   reg,unsigned char   *pBuf,unsigned char   len);    //ָĴָ
unsigned char      NRF24L01_Write_Buf(unsigned char   reg, unsigned char   *pBuf, unsigned char   len); //ָĴдָ
//----------------------------------------------------------------------
void  NRF24L01_TX_Mode(void);                       //Ϊģʽ
unsigned char      NRF24L01_TxPacket(unsigned char   *txbuf);                 //һ  32ֽ
unsigned char      NRF24L01_TxPacket_NUM(unsigned char   *txbuf,unsigned char   num);         //ָյַ0~5   5ΪĬϷ͵ַ
//--------------------------------------------------------------------
void  NRF24L01_RX_Mode(void);                       //Ϊģʽ
unsigned char      NRF24L01_RxPacket(unsigned char   *rxbuf,unsigned char   *num);         //һ ״̬  ȡͨ
//==================MPU6050===================================================
 
 
 extern unsigned char Re_buf[11],counter;
 extern unsigned char ucStra[6],ucStrw[6],ucStrAngle[6];
 extern unsigned      count_num;
 
 
  extern unsigned char count;               //ݸ¼


 extern  unsigned int  precision_x,precision_y,precision_z;  //X Y ZΪһα仯Ԥ徫 (0.5m/s2)
	extern unsigned int  changes_x,changes_y,changes_z;                    //X Y Zβ仯ֵ
	
 extern  unsigned int  Sample_result_x;  //ֵXٶ
 extern  unsigned int  Sample_result_y;  //ֵYٶ
 extern  unsigned int  Sample_result_z;  //ֵZٶ	
	
	extern unsigned int  Threshold_x;       //Xᶯֵ̬
 extern  unsigned int  Threshold_y;       //Yᶯֵ̬ 
 extern  unsigned int  Threshold_z;       //Zᶯֵ̬
	
	extern unsigned int  Sample_result_new_x;    
  extern unsigned int  Sample_result_new_y;    
 extern  unsigned int  Sample_result_new_z;    
	
	extern unsigned int  Sample_result_old_x;   
  extern unsigned int  Sample_result_old_y;   
 extern  unsigned int  Sample_result_old_z;   
 
 
extern   float  a[3];
extern   float  Acceleration_xyz;
          //ݸ¼ 
 //=====================GPS===========================================
 
 
extern unsigned char weidu[9];		       //γ
extern unsigned char jingdu[10];		   //   
#endif