#include "config.h"

 /*--------------------------------------------------------------------------
  $GPRMCƼλϢ(GPS) 
$GPRMC,<UTCʱ>,<Ч״̬>,<γ>,<γȰ>,<>,<Ȱ>,<>,<溽>,
       <UTC>,<ƫ>,<ƫǷ>,<ģʽָʾ>*<У><CR><LF> 
<UTCʱ>    hhmmss(ʱ)ʽҹʱ8СʱʱҪע  
<Ч״̬>   A=ЧV=Ч  
<γ>       ddmm.mmmm(ȷ)ʽ(ǰ0Ҳ) 
<γȰ>   N=S=ϰ 
<>       dddmm.mmmm(ȷ)ʽ(ǰ0Ҳ) 
<Ȱ>   E=W= 
<>   000.0-999.9(ǰ0Ҳ) 
<溽>   000.0-359.9ȣԱΪο׼(ǰ0Ҳ) 
<UTC>    ddmmyy()ʽҹʱ8СʱʱҪע 
<ƫ>     000.0~180.0(ǰ0Ҳ) 
<ƫǷ> E=W= 
<ģʽָʾ>   NMEA0183 3.00汾 A=λD=֣E=㣬N=Ч 
ӣ 
$GPRMC,085337.466,V,0000.0000,N,00000.0000,E,0.00,,200508,,*0B<CR><LF> 
$GPRMC,024813.640,A,3158.4608,N,11848.3737,E,10.05,324.27,150706,,,A*50 
-----------------------------------------------------------------------------*/   
unsigned char bdata RecFlag;					// ¼־	
sbit Dsign = RecFlag^0;
sbit Gsign = RecFlag^1;
sbit Psign = RecFlag^2;
sbit Rsign = RecFlag^3;
sbit Msign = RecFlag^4;
sbit Csign = RecFlag^5;
sbit Tod_On = RecFlag^6;
unsigned char NumComa;					               // ż
unsigned char time[10]={"0000000000"};	       //ʱ
unsigned char date[6]={"000000"};		           //
unsigned char weidu[9]={"00000000"};		       //γ
unsigned char jingdu[10]={"0000000000"};		   //         

unsigned char byte_count;		      //λ
unsigned char gps_flag = 0;      // GPS signal type , 'A' or 'V' for GPS signal   
 


//======================================================================================

serial2() interrupt 8 using 1 // UART2 interrupt
{
	unsigned char buf;	 
	if(S2CON & 0x01)   
	{
		IE2 = 0x00;     
		S2CON &=~(0x01); 
		buf = S2BUF;    	
		if (buf == 0x24)	// $ 
		{
			RecFlag = 0;
			Dsign =1;
			NumComa = 0;	// ż0
			byte_count = 0;
		}
		else if(buf == ',')				// got ',' 
		{
			NumComa++;
			byte_count =0;
			//===============================================================================
			if((NumComa == 1)&&(Csign !=1)	) RecFlag = 0; // $sign and GPRMC sign
			//===============================================================================
		}		
		if (Dsign == 1)
		{
			if ((buf == 'G') && (Gsign == 0 ))	{Gsign = 1;	}  
			if ((buf == 'P') && (Psign == 0 ))	{Psign = 1;	}
			if ((buf == 'R') && (Rsign == 0 ))	{Rsign = 1;	}
			if ((buf == 'M') && (Msign == 0 ))	{Msign = 1;	}
			if ((buf == 'C') && (Csign == 0 ))	{Csign = 1; }
		//ʱ
		 	if(NumComa == 1)
				{
					if (buf != ',')	  // ascii code ox2C = , and 0x2E = .
					{
						time[byte_count]=buf;
						byte_count++;
					}
				}
			else if (NumComa == 2)
				{
					if(buf != ',')	
					{
						gps_flag = buf;
// 						if ( gps_flag == 'A') BEEP=0;
// 						else BEEP = 1;
					}
				}
				//γ
			else if (NumComa ==3)
				{
				 	if(buf != ',' )
					{
						weidu[byte_count]=buf;
						byte_count++;
				 
					}
				}
				
			//ά
			else if (NumComa ==5)
				{
				 	if(buf != ',' )
					{
						jingdu[byte_count]=buf;
						byte_count++;
				 
					}
				}
				
				else if (NumComa ==9)
				{
				 	if(buf != ',' )
					{
						date[byte_count]=buf;
						byte_count++;
				 
					}
				}	
				
			if (buf == '*')
			{
				RecFlag = 0;
				NumComa = 0;			    	// ż0
				byte_count=0;
			 
			}
		}
		
		 IE2 = 0x01;             
	}
}

void  show_position(void)
{ 
  	unsigned  char i,j;
	  disp_string(1,1,"γ");
 

    for(i=0;i<9;i++)
   {
     write_data(weidu[i]);
   }
   disp_string(2,1,""); 
    for(j=0;j<10;j++)
 	 {
     write_data(jingdu[j]);
    }	 
}



