	#include <stc15.h>
	#include <string.h>
	#include <stdio.h>
	#include <12864.h>
	#include <math.h>
	unsigned char Re_buf[11],counter;
	unsigned char ucStra[6],ucStrw[6],ucStrAngle[6];
	unsigned int Sep[6]={0},Step_num[4];
	float P_east, P_north,P_east_his,P_north_his;
	int flag_sign;   //̬ڱ־
 
sbit CS=P0^5;	    //Ƭѡź
sbit SID=P0^6;		//ź
sbit SCLK=P0^7;		//ʱź 
sbit RST=P1^4;		//λź
sbit psb =P1^3;		//Сѡź
		//ʱ  //
	void delay(unsigned int t)
{
	unsigned int i,j;
	for(i=0; i<t;  i++)
    for(j=0; j<10; j++);
}
	void uart_int (void)  
	{
		
		SCON = 0x50;		
		AUXR |= 0x40;		
		AUXR &= 0xFE;		
		TMOD &= 0x0F;		
		TL1 = 0xE8;		
		TH1 = 0xFF;		
		ET1 = 0;		
		TR1 = 1;	
		TI=1;
		REN=1;          //ڳʼ
		SM0=0;
		SM1=1;
		EA=1;           //ж
		ES=1;
	}
	
	void lcdinit()
{  	
	psb = 0;
	delay(1);
	RST = 0;
	delay(100);
	RST = 1;
	delay(2000);
	write_com(0x30);
	delay(50);
	write_com(0x0c);
	delay(50);
	write_com(0x01);
	delay(1000);
	write_com(0x02);
	delay(1000);
	write_com(0x80);
	delay(1000);
}
/********************************************************************
*  : sendbyte()
*  : ҺĴͨЭ飬
*  : zdata
*  : 
***********************************************************************/
void sendbyte(unsigned char zdata)
{
	unsigned int i;
	for(i=0; i<8; i++)
	{
		if((zdata << i) & 0x80)
		{
			SID = 1;
		}
		else 
		{
			SID = 0;
		}
		SCLK = 0;
		SCLK = 1;
	}
}

/********************************************************************
*  : write_com()
*  : дָ
*  : cmdcode
*  : 
***********************************************************************/
void write_com(unsigned char cmdcode)
{
	unsigned char H_DAT,L_DAT;
	CS = 1;
	sendbyte(0xf8);
	H_DAT=cmdcode & 0xf0;
	sendbyte(H_DAT);
	L_DAT=cmdcode & 0x0f;
	L_DAT=L_DAT<<4;
	sendbyte(L_DAT);
	delay(2);
}

/********************************************************************
*  : write_data()
*  : дָ
*  : cmdcode
*  : 
***********************************************************************/
void write_data(unsigned char Dispdata)
{
	CS = 1;
	sendbyte(0xfa);
	sendbyte(Dispdata & 0xf0);
	sendbyte((Dispdata << 4) & 0xf0);
	delay(2);
}
unsigned char read_data(void)
{
		unsigned char temp;
		CS=1;
		
return temp;
}
void PRINTF(unsigned char x,unsigned char y,unsigned char  *p)
{ 
int z; 
if(x==1)
{
	z=0x80+y-0x01;
}
if(x==2)
{
	z=0x90+y-0x01;
}	
if(x==3)
{
	z=0x80+y+0x07;
}
if(x==4)
{
	z=0x90+y+0x07;
}
write_com(0x03) ;
delay(50);
write_com(z);
while(*p !=0)
{
    write_data(*p);
		p++;
		delay(100);
}
 
}

void PRINTFNUM(unsigned char x,unsigned char y,unsigned char num,unsigned char *word)
{
	int z,i; 
if(x==1)
{
	z=0x80+y-0x01;
}
if(x==2)
{
	z=0x90+y-0x01;
}	
if(x==3)
{
	z=0x80+y+0x07;
}
if(x==4)
{
	z=0x90+y+0x07;
}
   write_com(z);
	for(i=0;i<=num-1;i++)
	{
	write_data(word[i]);
   	}
}
		
void Step_Seperate(int Array,unsigned char z)
		{
				int m;
				if(Array>=10000)
					Array=0;
				
				Step_num[3]=Array%10;
				Step_num[2]=(int)(Array/10)%10;
				Step_num[1]=(int)(Array/100)%10;
				Step_num[0]=(int)(Array/1000);
				write_com(z);
				for(m=0;m<=3;m++)
						write_data(Step_num[m]+0x30);
		}
		
		
void Seperate(float Array,unsigned char z)
		{
			int i,flag,flag_num;
			if(Array<0)  //  + or -
			{
			  flag=0;    // -
				Array=-Array;
			}  	
			else
				flag=1;    // +
			
	  	Array=Array*100;	
			flag_num=Array/10000;  // hundred 1  or tens  0  
			if(flag&&(!flag_num))    // + tens
			{	 
					
				Sep[0]=(int)(Array/1000);		
				Sep[1]=(int)(Array/100)%10;			
				Sep[2]='.';		
				Sep[3]=(int)(Array/10)%10;
				Sep[4]=(int)Array%10;					
				if(Sep[4]>5)
					Sep[3]=Sep[3]+1;
				if(Sep[3]==10)
					Sep[3]=9;
				Sep[4]=' ';
				Sep[5]=' ';
				write_com(z);
				for(i=0;i<=5;i++)
				{
				if((Sep[i]>=0)&&(Sep[i]<=9))
						write_data(Sep[i]+0x30);
				else
						write_data(Sep[i]);
				}
			}
			if(flag&&flag_num)	    //  +  hundred
			{
				
				Sep[0]=(int)(Array/10000);				
			  Sep[1]=(int)(Array/1000)%10;			
				Sep[2]=(int)(Array/100)%10;				
				Sep[3]='.';				
				Sep[4]=(int)(Array/10)%10;				
				Sep[5]=(int)Array%10;	
				if(Sep[5]>5)
					Sep[4]=Sep[4]+1;
				if(Sep[4]==10)
					Sep[4]=9;
				Sep[5]=' ';
				write_com(z);
				for(i=0;i<=5;i++)
				{
				if((Sep[i]>=0)&&(Sep[i]<=9))
						write_data(Sep[i]+0x30);
				else
						write_data(Sep[i]);
				}
		  	}
				
			
			if((!flag)&&(!flag_num))     //  -  tens
			{
				Sep[0]='-';
				Sep[1]=(int)(Array/1000);
				Sep[2]=(int)(Array/100)%10;
			  Sep[3]='.';
				Sep[4]=(int)(Array/10)%10;
				Sep[5]=(int)Array%10;
				if(Sep[5]>5)
					Sep[4]=Sep[4]+1;
				if(Sep[4]==10)
					Sep[4]=9;
				Sep[5]=' ';
				write_com(z);
				for(i=0;i<=5;i++)
				{
				if((Sep[i]>=0)&&(Sep[i]<=9))
						write_data(Sep[i]+0x30);
				else
						write_data(Sep[i]);
				}
				}
		  
			if((!flag)&&flag_num)     // -  hundred
			{
				Sep[0]='-';
				Sep[1]=(int)(Array/10000);
			  Sep[2]=(int)(Array/1000)%10;
				Sep[3]=(int)(Array/100)%10;
				Sep[4]='.';
				Sep[5]=(int)(Array/10)%10;
				Sep[6]=(int)Array%10;
				if(Sep[6]>5)
					Sep[5]=Sep[5]+1;
				if(Sep[5]==10)
					Sep[5]=9;
				Sep[6]=' ';
			  write_com(z);
				for(i=0;i<=5;i++)
				{
				if((Sep[i]>=0)&&(Sep[i]<=9))
						write_data(Sep[i]+0x30);
				else
						write_data(Sep[i]);
				};
				}
			
		}
		// Ʋ㷨//
int  cal_step(float ax,float ay,float az)
{
	float Aa;
	float Sn;//ٶȣٶȣƫ
	float Aa_his=0,Aa_his2=0,Aa_his3=0,Aa_his4=0;
	float Aa_ave;
	float c,step_num=0;
	int flag;
  Aa=ax*ax+ay*ay+az*az;
	
	Aa_ave=(Aa+Aa_his+Aa_his2+Aa_his3+Aa_his4)/5;
	Sn=((Aa-Aa_ave)*(Aa-Aa_ave)+(Aa_his-Aa_ave)*(Aa_his-Aa_ave)+(Aa_his2-Aa_ave)*
	(Aa_his2-Aa_ave)+(Aa_his3-Aa_ave)*(Aa_his3-Aa_ave)+(Aa_his4-Aa_ave)*(Aa_his4-Aa_ave))/5;
	Aa_his4=Aa_his3;
	Aa_his3=Aa_his2;
	Aa_his2=Aa_his ;
	Aa_his =Aa;
	if(Aa>4.2)  //GAI
	//	{
		if(Sn<20)
	//			{
	//				 if(Ww>100)	
					 c=0;
					 else
					 c=1;
	//			}
	//		else
	//		c=1;
	//	}
	else
	 c=1;     //c=0,վڣc=1
if(c==0)
	flag=1;

if(c==1&&flag==1)
	{
		step_num=1;
		c=0;
		flag=0;
    flag_sign=(int)step_num%2;		
	}
  return step_num;
} 
/*float step_length(float x,float y,float z)
{
	float Stride;
	float A, Amax=0, Amin=0, Asqrt;	
	float Stride;
	A=sqrt(x*x+y*y+z*z);
	if(flag_sign==0)
	{
	if(A>Amax)			
		Amax=A;
	if(A<Amin)
		Amin=A;
  }
	if(flag_sign==1)
	{
	if(A>Amax)			
		Amax=A;
	if(A<Amin)
		Amin=A;
  }
	Asqrt=sqrt(sqrt(Amax-Amin));
	Stride=1.05*Asqrt;
	
	Stride=0.8;
	return Stride;
} 	
 */

void HJDT(float angle, float Ln)    //   //
{
		
		P_east =P_east_his + Ln*cos(angle);
	  P_north=P_north_his + Ln*sin(angle);
	  P_east_his =P_east;
	  P_north_his=P_north;
}	

/*void Draw_clean(void)
{
		unsigned char i,j,k;
	  write_com(0x34);
	  
	 write_com(0x34);
	
	for(i=0;i<2;i++)
	{
		for(j=0;j<32;j++)
		{
			write_com(0x80+j);
			delay(1);
			if(i==0)
			{
				write_com(0x80);
			delay(1);
			}
			else
			{
				write_com(0x88);
				delay(1);
			}
			for(k=0;k<16;k++)
			{
				write_data(0x00);
				write_data(0x00);
				delay(1);
			}
		}
	}
		write_com(0x36);
	
	  write_com(0x30);
	  
}
void set_dot(unsigned char x,unsigned char y)
{
		unsigned char x_bite,x_bit, y_ping,y_bit;
     unsigned char tmph, tmpl;
	write_com(0x34);
	delay(100);
	write_com(0x34);
	delay(100);
	x_bite=x/16;
	x_bit=x%16;
	y_ping=y/32;
	y_bit=y%32;
	write_com(0x80+y_bit);
	write_com(0x80+x_bite+8*y_ping);
	tmph=0;tmpl=0;
	delay(100);
	if(x_bit<8)
	{
		write_data(tmph|0x01<<(7-x_bit));
	write_data(tmpl);
	}
		else
		{
		write_data(tmph);
		write_data(tmpl|0x01<<(15-x_bit));
		}
		write_com(0x36);
		write_com(0x30);
		}
void h_line(unsigned char x0,unsigned char x1,unsigned char y)
{
	unsigned char bak;
	if(x0>x1)
	{
		bak=x1;
		x1=x0;
		x0=bak;
	}
	do
	{
		set_dot(x0,y);
		x0++;
	}
	while(x1>=x0);
}
void r_line(unsigned char x,unsigned char y0,unsigned char y1)
{
unsigned char bak;
	if(y0>y1)
	{
		bak=y1;
		y1=y0;
		y0=bak;
	}
	do
	{
		set_dot(x,y0);
		y0++;
	}
	while(y1>=y0);
}
void line(unsigned char x0,unsigned char y0,unsigned char x1,unsigned char y1)
{
	char dx,dy,dx_sym,dy_sym,dx_x2,dy_x2;
	char di;
	if(x0==x1)
	{
		r_line(x0,y0,y1);
	return;
	}
	if(y0==y1)
	{
		h_line(x0,x1,y0);
		return;
	}
	dx=x1-x0;
	dy=y1-y0;
	if(dx>0)
		dx_sym=1;
	else
	{
		if(dx<0)
			dx_sym=-1;
		else
		{
			r_line(x0,y0,y1);
			return;
		}
	}
	if(dy>0)
		dy_sym=1;
	else
	{
		if(dy<0)
			dy_sym=-1;
		else
		{
			r_line(x0,x1,y1);
			return;
		}
	}
dx=dx_sym*dx;
	dy=dy_sym*dy;
	dx_x2=dx*1;
	dy_x2=dy*1;
	if(dx>=dy)
	{
		di=dy_x2-dx;
		while(x0!=x1)
		{
			set_dot(x0,y0);
			x0+=dx_sym;
			if(di<0)
				di+=dy_x2;
			else
			{
				di+=dy_x2-dx_x2;
				y0+=dy_sym;
			}
		}
		set_dot(x0,y0);
	}
	else
	{
		di=dx_x2-dy;
		while(y0!=y1)
		{
			set_dot(x0,y0);
			y0+=dy_sym;
			if(di<0)
				di+=dx_x2;
			else
			{
				di+=dx_x2-dy_x2;
				x0+=dx_sym;
			}
		}
		set_dot(x0,y0);
	}

}
*/
	void main(void)
	{
	 	float Accelerate[3],Omega[3],Angle[3];
//		unsigned char i;
		float Angle_ave[3];
		int STEP=0,STEP_1;
		float Length,Distance;
		
		uart_int ();
		delay(2000);
    lcdinit();
		delay(2000);
		PRINTF(1,1,"ת");
		PRINTF(2,1,"");
		PRINTF(3,1,"ƫ");
//		lcdinit();
		
//		Draw_clean();
//		delay(10);
///		set_dot(0xaf,0xfa);
//		h_line(0x0a,0x0f,0xea);
//		r_line(0x0a,0x0f,0xea);
//		line(0x0a,0xea,0x0f,0xea);
		PRINTF(4,1,"Ʋ");
		while(1)
		{
		 	Angle_ave[0]=0;
			Angle_ave[1]=0;
			Angle_ave[2]=0;
		
			Accelerate[0] = ((short)(ucStra[1]<<8| ucStra[0]))/32768.0*16;
			Accelerate[1] = ((short)(ucStra[3]<<8| ucStra[2]))/32768.0*16;
			Accelerate[2] = ((short)(ucStra[5]<<8| ucStra[4]))/32768.0*16;
		 	Omega[0] = ((short)(ucStrw[1]<<8| ucStrw[0]))/32768.0*2000;
			Omega[1] = ((short)(ucStrw[3]<<8| ucStrw[2]))/32768.0*2000;
			Omega[2] = ((short)(ucStrw[5]<<8| ucStrw[4]))/32768.0*2000;
			
			STEP_1=cal_step(Accelerate[0],Accelerate[1],Accelerate[2]);
			STEP=STEP+STEP_1;
			Length=0.8;
			Distance=STEP*Length;
			if(Distance>=2)
				HJDT(Angle[2],Distance);
				
			
		 	Angle[0] = ((short)(ucStrAngle[1]<<8| ucStrAngle[0]))/32768.0*180;
			Angle[1] = ((short)(ucStrAngle[3]<<8| ucStrAngle[2]))/32768.0*180;
			Angle[2] = ((short)(ucStrAngle[5]<<8| ucStrAngle[4]))/32768.0*180;
			Angle_ave[0]=Angle_ave[0]+Angle[0];
			Angle_ave[1]=Angle_ave[1]+Angle[1];
			Angle_ave[2]=Angle_ave[2]+Angle[2];
		  
		
		  Seperate(Angle_ave[0]/5,0x84);
			Seperate(Angle_ave[1]/5,0x94);
			Seperate(Angle_ave[2]/5,0x8c);
			Step_Seperate(STEP,0X9C);
	//		Seperate(Distance,0X98);
	  }	

	}

	
	
	
		/*ܴ*/
	void ser() interrupt 4
{
	if (RI)
	{
		RI=0;
		Re_buf[counter]=SBUF;	
	
	    if(counter==0&&Re_buf[0]!=0x55) return;      //0ݲ֡ͷ
	              
	    counter++; 
	    if(counter==11)             //յ11
	    {    
	       counter=0;               //¸ֵ׼һ֡ݵĽ        
			switch(Re_buf [1])
			{
			case 0x51:
			ucStra[0]=Re_buf[2];
			ucStra[1]=Re_buf[3];
			ucStra[2]=Re_buf[4];
			ucStra[3]=Re_buf[5];
			ucStra[4]=Re_buf[6];
			ucStra[5]=Re_buf[7];
			break;
			case 0x52:	 
			ucStrw[0]=Re_buf[2];
			ucStrw[1]=Re_buf[3];
			ucStrw[2]=Re_buf[4];
			ucStrw[3]=Re_buf[5];
			ucStrw[4]=Re_buf[6];
			ucStrw[5]=Re_buf[7];
			break;
			case 0x53: 
			ucStrAngle[0]=Re_buf[2];
			ucStrAngle[1]=Re_buf[3];
			ucStrAngle[2]=Re_buf[4];
			ucStrAngle[3]=Re_buf[5];
			ucStrAngle[4]=Re_buf[6];
			ucStrAngle[5]=Re_buf[7];	
			break;
			} 
	      }
	  }
    
}